'	Program :	Alone.pl
	Author  :	H. Piske
	Written :	2001-03-28
	Purpose :	demonstrate sole window on black desktop
';

use Win32::GUI;
use Win32::API;

BEGIN
{
	undef $blank;
	undef @hidden;
	$CreateWindowEx = new Win32::API ('user32', $_ = 'CreateWindowEx',
		[N,P,P,N,I,I,I,I,I,I,I,P], I) or die $_;
	$ShowWindow = new Win32::API ('user32', $_ = 'ShowWindow', [I, I], I)
		or die $_;
	$DestroyWindow = new Win32::API ('user32', $_ = 'DestroyWindow', [I], I)
		or die $_;
}
END
{
	$ShowWindow->Call ($_, 8) for @hidden;
	$DestroyWindow->Call ($blank) if $blank;
	undef $CreateWindowEx;
	undef $DestroyWindow;
	undef $ShowWindow;
}

$Main = new Win32::GUI::Window
(
	-name => 'Main',
	-pos => [100, 100],
	-size => [400, 300],
);
sub Main_Terminate
{
	-1;
}
$Main->AddLabel
(
	-name => $_ = 'All alone!',
	-text => $_,
	-pos => [160, 110],
);

$_ = $Main->GetWindow (GW_HWNDLAST);
do
{
	if (Win32::GUI::IsVisible ($_))
	{
		push @hidden, $_;
		$ShowWindow->Call ($_, 0);
	}
} while $_ = Win32::GUI::GetWindow ($_, GW_HWNDPREV);

$desktop = $Main->GetDesktopWindow ();
@area = Win32::GUI::GetWindowRect ($desktop);
$blank = $CreateWindowEx->Call (0, $_ = 'STATIC', '', 
	0x5C000004, @area, $desktop, 0, 0, 0) or die $_;
$Main->Show ();
Win32::GUI::Dialog ();
